/*!
 * wbm-legal-information@1.2.1
 * 
 *   Copyright © 2019 WAGO Kontakttechnik GmbH & Co. KG
 * 
 *   License: 
 *     WAGO Software License Agreement
 * 
 *   Contributors:
 *     Marius Hellmeier <marius.hellmeier@wago.com>
 *   Johann Dück <johann.dueck@wago.com>
 *   Stefanie Meihöfer <stefanie.meihoefer@wago.com>
 * 
 *   Description:
 *     Displays a legal information menu with wago and open source license pages
 * 
 *   
 */
!function(e,t){"object"==typeof exports&&"object"==typeof module?module.exports=t():"function"==typeof define&&define.amd?define([],t):"object"==typeof exports?exports["legal-information"]=t():e["legal-information"]=t()}(this,function(){return function(e){function t(r){if(n[r])return n[r].exports;var o=n[r]={i:r,l:!1,exports:{}};return e[r].call(o.exports,o,o.exports,t),o.l=!0,o.exports}var n={};return t.m=e,t.c=n,t.d=function(e,n,r){t.o(e,n)||Object.defineProperty(e,n,{configurable:!1,enumerable:!0,get:r})},t.n=function(e){var n=e&&e.__esModule?function(){return e.default}:function(){return e};return t.d(n,"a",n),n},t.o=function(e,t){return Object.prototype.hasOwnProperty.call(e,t)},t.p="",t(t.s=4)}([function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var r=function(){function e(e){this.base=e}return e.prototype.onRouteChange=function(e){},e.prototype.unload=function(){},e}();t.ViewController=r},function(e,t){function n(e,t){var n=e[1]||"",o=e[3];if(!o)return n;if(t&&"function"==typeof btoa){var i=r(o);return[n].concat(o.sources.map(function(e){return"/*# sourceURL="+o.sourceRoot+e+" */"})).concat([i]).join("\n")}return[n].join("\n")}function r(e){return"/*# sourceMappingURL=data:application/json;charset=utf-8;base64,"+btoa(unescape(encodeURIComponent(JSON.stringify(e))))+" */"}e.exports=function(e){var t=[];return t.toString=function(){return this.map(function(t){var r=n(t,e);return t[2]?"@media "+t[2]+"{"+r+"}":r}).join("")},t.i=function(e,n){"string"==typeof e&&(e=[[null,e,""]]);for(var r={},o=0;o<this.length;o++){var i=this[o][0];"number"==typeof i&&(r[i]=!0)}for(o=0;o<e.length;o++){var a=e[o];"number"==typeof a[0]&&r[a[0]]||(n&&!a[2]?a[2]=n:n&&(a[2]="("+a[2]+") and ("+n+")"),t.push(a))}},t}},function(e,t,n){function r(e,t){for(var n=0;n<e.length;n++){var r=e[n],o=d[r.id];if(o){o.refs++;for(var i=0;i<o.parts.length;i++)o.parts[i](r.parts[i]);for(;i<r.parts.length;i++)o.parts.push(u(r.parts[i],t))}else{for(var a=[],i=0;i<r.parts.length;i++)a.push(u(r.parts[i],t));d[r.id]={id:r.id,refs:1,parts:a}}}}function o(e,t){for(var n=[],r={},o=0;o<e.length;o++){var i=e[o],a=t.base?i[0]+t.base:i[0],s=i[1],l=i[2],c=i[3],u={css:s,media:l,sourceMap:c};r[a]?r[a].parts.push(u):n.push(r[a]={id:a,parts:[u]})}return n}function i(e,t){var n=v(e.insertInto);if(!n)throw new Error("Couldn't find a style target. This probably means that the value for the 'insertInto' parameter is invalid.");var r=w[w.length-1];if("top"===e.insertAt)r?r.nextSibling?n.insertBefore(t,r.nextSibling):n.appendChild(t):n.insertBefore(t,n.firstChild),w.push(t);else if("bottom"===e.insertAt)n.appendChild(t);else{if("object"!=typeof e.insertAt||!e.insertAt.before)throw new Error("[Style Loader]\n\n Invalid value for parameter 'insertAt' ('options.insertAt') found.\n Must be 'top', 'bottom', or Object.\n (https://github.com/webpack-contrib/style-loader#insertat)\n");var o=v(e.insertInto+" "+e.insertAt.before);n.insertBefore(t,o)}}function a(e){if(null===e.parentNode)return!1;e.parentNode.removeChild(e);var t=w.indexOf(e);t>=0&&w.splice(t,1)}function s(e){var t=document.createElement("style");return e.attrs.type="text/css",c(t,e.attrs),i(e,t),t}function l(e){var t=document.createElement("link");return e.attrs.type="text/css",e.attrs.rel="stylesheet",c(t,e.attrs),i(e,t),t}function c(e,t){Object.keys(t).forEach(function(n){e.setAttribute(n,t[n])})}function u(e,t){var n,r,o,i;if(t.transform&&e.css){if(!(i=t.transform(e.css)))return function(){};e.css=i}if(t.singleton){var c=g++;n=y||(y=s(t)),r=f.bind(null,n,c,!1),o=f.bind(null,n,c,!0)}else e.sourceMap&&"function"==typeof URL&&"function"==typeof URL.createObjectURL&&"function"==typeof URL.revokeObjectURL&&"function"==typeof Blob&&"function"==typeof btoa?(n=l(t),r=h.bind(null,n,t),o=function(){a(n),n.href&&URL.revokeObjectURL(n.href)}):(n=s(t),r=p.bind(null,n),o=function(){a(n)});return r(e),function(t){if(t){if(t.css===e.css&&t.media===e.media&&t.sourceMap===e.sourceMap)return;r(e=t)}else o()}}function f(e,t,n,r){var o=n?"":r.css;if(e.styleSheet)e.styleSheet.cssText=x(t,o);else{var i=document.createTextNode(o),a=e.childNodes;a[t]&&e.removeChild(a[t]),a.length?e.insertBefore(i,a[t]):e.appendChild(i)}}function p(e,t){var n=t.css,r=t.media;if(r&&e.setAttribute("media",r),e.styleSheet)e.styleSheet.cssText=n;else{for(;e.firstChild;)e.removeChild(e.firstChild);e.appendChild(document.createTextNode(n))}}function h(e,t,n){var r=n.css,o=n.sourceMap,i=void 0===t.convertToAbsoluteUrls&&o;(t.convertToAbsoluteUrls||i)&&(r=m(r)),o&&(r+="\n/*# sourceMappingURL=data:application/json;base64,"+btoa(unescape(encodeURIComponent(JSON.stringify(o))))+" */");var a=new Blob([r],{type:"text/css"}),s=e.href;e.href=URL.createObjectURL(a),s&&URL.revokeObjectURL(s)}var d={},b=function(e){var t;return function(){return void 0===t&&(t=e.apply(this,arguments)),t}}(function(){return window&&document&&document.all&&!window.atob}),v=function(e){var t={};return function(n){if(void 0===t[n]){var r=e.call(this,n);if(r instanceof window.HTMLIFrameElement)try{r=r.contentDocument.head}catch(e){r=null}t[n]=r}return t[n]}}(function(e){return document.querySelector(e)}),y=null,g=0,w=[],m=n(9);e.exports=function(e,t){if("undefined"!=typeof DEBUG&&DEBUG&&"object"!=typeof document)throw new Error("The style-loader cannot be used in a non-browser environment");t=t||{},t.attrs="object"==typeof t.attrs?t.attrs:{},t.singleton||(t.singleton=b()),t.insertInto||(t.insertInto="head"),t.insertAt||(t.insertAt="bottom");var n=o(e,t);return r(n,t),function(e){for(var i=[],a=0;a<n.length;a++){var s=n[a],l=d[s.id];l.refs--,i.push(l)}e&&r(o(e,t),t);for(var a=0;a<i.length;a++){var l=i[a];if(0===l.refs){for(var c=0;c<l.parts.length;c++)l.parts[c]();delete d[l.id]}}}};var x=function(){var e=[];return function(t,n){return e[t]=n,e.filter(Boolean).join("\n")}}()},function(e,t,n){var r=n(11);"string"==typeof r&&(r=[[e.i,r,""]]);var o={hmr:!0};o.transform=void 0,n(2)(r,o),r.locals&&(e.exports=r.locals)},function(e,t,n){"use strict";function r(e){return i(this,void 0,void 0,function(){var t,n,r,i,p,h,d,b,v,y;return a(this,function(a){return t=e.plugin.getResourceUrl("wbm-legal-information"),n=new u.LicenseLoader(t+"/platform/pfcXXX/licenses.php"),r={id:"legal-information",title:{fallback:"Legal Information",key:"legal-information-menu-title"},priority:10},i=e.subframeGenerator.createSubFrame(r.id,e,["legal-information"]),p={id:"open-source-licenses",title:{fallback:"Open Source Licenses",key:"open-source-licenses-menu-title"},priority:100,userRoles:[f.UserRoles.admin,f.UserRoles.user]},h={title:{default:"Open Source Licenses",localized:"open-source-licenses"},content:[new s.OSSLicenses(e,n)]},i.registerSubMenuItem(o({},p,{title:e.localization.localized(p.title)}),e.viewGenerator.generate(e,h)),d={id:"wago-licenses",title:{fallback:"WAGO Licenses",key:"wago-licenses-menu-title"},priority:150},b={title:{default:"WAGO Software License Agreement",localized:"wago-software-license-agreement"},content:[new l.WAGOLicenses(e,n)]},i.registerSubMenuItem(o({},d,{title:e.localization.localized(d.title)}),e.viewGenerator.generate(e,b)),v={id:"wbm-licenses",title:{fallback:"WBM Licenses",key:"wbm-licenses-menu-title"},priority:50,userRoles:[f.UserRoles.admin,f.UserRoles.user]},y={title:{default:"WBM Third Party License Information",localized:"wbm-licenses-page-title"},content:[new c.WBMLicenses(e)]},i.registerSubMenuItem(o({},v,{title:e.localization.localized(v.title)}),e.viewGenerator.generate(e,y)),[2,o({},r,{controller:i})]})})}var o=this&&this.__assign||Object.assign||function(e){for(var t,n=1,r=arguments.length;n<r;n++){t=arguments[n];for(var o in t)Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o])}return e},i=this&&this.__awaiter||function(e,t,n,r){return new(n||(n=Promise))(function(o,i){function a(e){try{l(r.next(e))}catch(e){i(e)}}function s(e){try{l(r.throw(e))}catch(e){i(e)}}function l(e){e.done?o(e.value):new n(function(t){t(e.value)}).then(a,s)}l((r=r.apply(e,t||[])).next())})},a=this&&this.__generator||function(e,t){function n(e){return function(t){return r([e,t])}}function r(n){if(o)throw new TypeError("Generator is already executing.");for(;l;)try{if(o=1,i&&(a=2&n[0]?i.return:n[0]?i.throw||((a=i.return)&&a.call(i),0):i.next)&&!(a=a.call(i,n[1])).done)return a;switch(i=0,a&&(n=[2&n[0],a.value]),n[0]){case 0:case 1:a=n;break;case 4:return l.label++,{value:n[1],done:!1};case 5:l.label++,i=n[1],n=[0];continue;case 7:n=l.ops.pop(),l.trys.pop();continue;default:if(a=l.trys,!(a=a.length>0&&a[a.length-1])&&(6===n[0]||2===n[0])){l=0;continue}if(3===n[0]&&(!a||n[1]>a[0]&&n[1]<a[3])){l.label=n[1];break}if(6===n[0]&&l.label<a[1]){l.label=a[1],a=n;break}if(a&&l.label<a[2]){l.label=a[2],l.ops.push(n);break}a[2]&&l.ops.pop(),l.trys.pop();continue}n=t.call(e,l)}catch(e){n=[6,e],i=0}finally{o=a=0}if(5&n[0])throw n[1];return{value:n[0]?n[1]:void 0,done:!0}}var o,i,a,s,l={label:0,sent:function(){if(1&a[0])throw a[1];return a[1]},trys:[],ops:[]};return s={next:n(0),throw:n(1),return:n(2)},"function"==typeof Symbol&&(s[Symbol.iterator]=function(){return this}),s};Object.defineProperty(t,"__esModule",{value:!0});var s=n(5),l=n(12),c=n(13),u=n(14),f=n(15);base.plugin.register("wbm-legal-information",r)},function(e,t,n){"use strict";var r=this&&this.__extends||function(){var e=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var n in t)t.hasOwnProperty(n)&&(e[n]=t[n])};return function(t,n){function r(){this.constructor=t}e(t,n),t.prototype=null===n?Object.create(n):(r.prototype=n.prototype,new r)}}(),o=this&&this.__awaiter||function(e,t,n,r){return new(n||(n=Promise))(function(o,i){function a(e){try{l(r.next(e))}catch(e){i(e)}}function s(e){try{l(r.throw(e))}catch(e){i(e)}}function l(e){e.done?o(e.value):new n(function(t){t(e.value)}).then(a,s)}l((r=r.apply(e,t||[])).next())})},i=this&&this.__generator||function(e,t){function n(e){return function(t){return r([e,t])}}function r(n){if(o)throw new TypeError("Generator is already executing.");for(;l;)try{if(o=1,i&&(a=2&n[0]?i.return:n[0]?i.throw||((a=i.return)&&a.call(i),0):i.next)&&!(a=a.call(i,n[1])).done)return a;switch(i=0,a&&(n=[2&n[0],a.value]),n[0]){case 0:case 1:a=n;break;case 4:return l.label++,{value:n[1],done:!1};case 5:l.label++,i=n[1],n=[0];continue;case 7:n=l.ops.pop(),l.trys.pop();continue;default:if(a=l.trys,!(a=a.length>0&&a[a.length-1])&&(6===n[0]||2===n[0])){l=0;continue}if(3===n[0]&&(!a||n[1]>a[0]&&n[1]<a[3])){l.label=n[1];break}if(6===n[0]&&l.label<a[1]){l.label=a[1],a=n;break}if(a&&l.label<a[2]){l.label=a[2],l.ops.push(n);break}a[2]&&l.ops.pop(),l.trys.pop();continue}n=t.call(e,l)}catch(e){n=[6,e],i=0}finally{o=a=0}if(5&n[0])throw n[1];return{value:n[0]?n[1]:void 0,done:!0}}var o,i,a,s,l={label:0,sent:function(){if(1&a[0])throw a[1];return a[1]},trys:[],ops:[]};return s={next:n(0),throw:n(1),return:n(2)},"function"==typeof Symbol&&(s[Symbol.iterator]=function(){return this}),s};Object.defineProperty(t,"__esModule",{value:!0});var a=n(0),s=n(6);n(3);var l=function(e){function t(t,n){var r=e.call(this,t)||this;return r.view=document.createElement("wbm-legal-information-oss-licenses"),r.licenseLoader=n,r}return r(t,e),Object.defineProperty(t.prototype,"paragraph",{get:function(){var e=this.view.querySelector("p");return e&&e.textContent||""},set:function(e){var t=this.view.querySelector("p");e?(t||(t=document.createElement("p"),t.classList.add("license-page-text"),this.view.insertBefore(t,this.view.firstElementChild)),t.textContent=e):t&&t.remove()},enumerable:!0,configurable:!0}),t.prototype.appendPackage=function(e,t){var n=this.view.querySelector(".license-packages-list");n||(n=document.createElement("div"),n.classList.add("license-packages-list"),this.view.appendChild(n));var r=new s.LicenseBox(this.base,t,this.licenseLoader);r.title=e,n.appendChild(r.view)},t.prototype.load=function(){return o(this,void 0,void 0,function(){var e,t,n,r,o,a;return i(this,function(i){switch(i.label){case 0:this.view.innerHTML="",i.label=1;case 1:return i.trys.push([1,4,,5]),e=this,[4,this.licenseLoader.getOSSDisclaimer()];case 2:return e.paragraph=i.sent(),[4,this.licenseLoader.getOSSPackageList()];case 3:for(t=i.sent(),n=0,r=t;n<r.length;n++)o=r[n],this.appendPackage(o.name+" "+o.version,o.id);return[3,5];case 4:return a=i.sent(),this.base.modalPresenter.showErrorDialog(this.base,{title:this.base.localization.localized({key:"error-while-loading-oss-list-modal-title",fallback:"Error"}),message:this.base.localization.localized({key:"error-while-loading-oss-list-modal-message",fallback:"Failed to load open source package list."}),detailMessage:a.message}),[3,5];case 5:return[2]}})})},t}(a.ViewController);t.OSSLicenses=l},function(e,t,n){"use strict";var r=this&&this.__extends||function(){var e=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var n in t)t.hasOwnProperty(n)&&(e[n]=t[n])};return function(t,n){function r(){this.constructor=t}e(t,n),t.prototype=null===n?Object.create(n):(r.prototype=n.prototype,new r)}}(),o=this&&this.__awaiter||function(e,t,n,r){return new(n||(n=Promise))(function(o,i){function a(e){try{l(r.next(e))}catch(e){i(e)}}function s(e){try{l(r.throw(e))}catch(e){i(e)}}function l(e){e.done?o(e.value):new n(function(t){t(e.value)}).then(a,s)}l((r=r.apply(e,t||[])).next())})},i=this&&this.__generator||function(e,t){function n(e){return function(t){return r([e,t])}}function r(n){if(o)throw new TypeError("Generator is already executing.");for(;l;)try{if(o=1,i&&(a=2&n[0]?i.return:n[0]?i.throw||((a=i.return)&&a.call(i),0):i.next)&&!(a=a.call(i,n[1])).done)return a;switch(i=0,a&&(n=[2&n[0],a.value]),n[0]){case 0:case 1:a=n;break;case 4:return l.label++,{value:n[1],done:!1};case 5:l.label++,i=n[1],n=[0];continue;case 7:n=l.ops.pop(),l.trys.pop();continue;default:if(a=l.trys,!(a=a.length>0&&a[a.length-1])&&(6===n[0]||2===n[0])){l=0;continue}if(3===n[0]&&(!a||n[1]>a[0]&&n[1]<a[3])){l.label=n[1];break}if(6===n[0]&&l.label<a[1]){l.label=a[1],a=n;break}if(a&&l.label<a[2]){l.label=a[2],l.ops.push(n);break}a[2]&&l.ops.pop(),l.trys.pop();continue}n=t.call(e,l)}catch(e){n=[6,e],i=0}finally{o=a=0}if(5&n[0])throw n[1];return{value:n[0]?n[1]:void 0,done:!0}}var o,i,a,s,l={label:0,sent:function(){if(1&a[0])throw a[1];return a[1]},trys:[],ops:[]};return s={next:n(0),throw:n(1),return:n(2)},"function"==typeof Symbol&&(s[Symbol.iterator]=function(){return this}),s};Object.defineProperty(t,"__esModule",{value:!0});var a=n(0);n(7);var s=function(e){function t(t,r,o){var i=e.call(this,t)||this;return i.loadingOrLoaded=!1,i.packageId=r,i.licenseLoader=o,i.view=document.createElement("wbm-legal-information-license-box"),i.view.innerHTML=n(10),i.view.querySelector("h4.title").addEventListener("click",function(){var e=i.view.querySelector("div.collapsible");e.classList.toggle("collapsed"),e.classList.contains("collapsed")||i.loadingOrLoaded||i.load()}),i}return r(t,e),Object.defineProperty(t.prototype,"title",{get:function(){return this.view.querySelector("h4.title").textContent||""},set:function(e){this.view.querySelector("h4.title").textContent=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"text",{get:function(){return this.view.querySelector("p.text").textContent||""},set:function(e){this.view.querySelector("p.text").textContent=e},enumerable:!0,configurable:!0}),t.prototype.load=function(){return o(this,void 0,void 0,function(){var e,t;return i(this,function(n){switch(n.label){case 0:this.loadingOrLoaded=!0,n.label=1;case 1:return n.trys.push([1,3,,4]),e=this,[4,this.licenseLoader.getOSSPackageLicense(this.packageId)];case 2:return e.text=n.sent(),[3,4];case 3:return t=n.sent(),this.base.modalPresenter.showErrorDialog(this.base,{title:this.base.localization.localized({key:"error-while-loading-oss-license-modal-title",fallback:"Error"}),message:this.base.localization.localized({key:"error-while-loading-oss-license-modal-message",fallback:"Failed to load open source license text resource for package "+this.packageId+"."}),detailMessage:t.message}),[3,4];case 4:return[2]}})})},t}(a.ViewController);t.LicenseBox=s},function(e,t,n){var r=n(8);"string"==typeof r&&(r=[[e.i,r,""]]);var o={hmr:!0};o.transform=void 0,n(2)(r,o),r.locals&&(e.exports=r.locals)},function(e,t,n){t=e.exports=n(1)(void 0),t.push([e.i,'div.collapsible{border:1px solid #ccc;margin:17px 0}div.collapsible>h4.title{margin:0;height:34px;cursor:pointer;background:#f0f0f0;position:relative;line-height:34px;padding:0 9px}div.collapsible>h4.title:after{font-family:Material Icons;font-weight:400;font-style:normal;font-size:24px;display:inline-block;line-height:1;text-transform:none;letter-spacing:normal;word-wrap:normal;white-space:nowrap;direction:ltr;-webkit-font-smoothing:antialiased;text-rendering:optimizeLegibility;-moz-osx-font-smoothing:grayscale;font-feature-settings:"liga";font-size:14px;content:"expand_more";top:10px;right:9px;position:absolute}div.collapsible>p.text{padding:17px 9px;white-space:pre-wrap;overflow-wrap:break-word}div.collapsible.collapsed>p.text{display:none}div.collapsible.collapsed>h4.title:after{content:"expand_less"}',""])},function(e,t){e.exports=function(e){var t="undefined"!=typeof window&&window.location;if(!t)throw new Error("fixUrls requires window.location");if(!e||"string"!=typeof e)return e;var n=t.protocol+"//"+t.host,r=n+t.pathname.replace(/\/[^\/]*$/,"/");return e.replace(/url\s*\(((?:[^)(]|\((?:[^)(]+|\([^)(]*\))*\))*)\)/gi,function(e,t){var o=t.trim().replace(/^"(.*)"$/,function(e,t){return t}).replace(/^'(.*)'$/,function(e,t){return t});if(/^(#|data:|http:\/\/|https:\/\/|file:\/\/\/)/i.test(o))return e;var i;return i=0===o.indexOf("//")?o:0===o.indexOf("/")?n+o:r+o.replace(/^\.\//,""),"url("+JSON.stringify(i)+")"})}},function(e,t){e.exports='<div class="collapsible collapsed"> <h4 class=title></h4> <p class=text></p> </div>'},function(e,t,n){t=e.exports=n(1)(void 0),t.push([e.i,".license-page-text{white-space:pre-wrap}",""])},function(e,t,n){"use strict";var r=this&&this.__extends||function(){var e=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var n in t)t.hasOwnProperty(n)&&(e[n]=t[n])};return function(t,n){function r(){this.constructor=t}e(t,n),t.prototype=null===n?Object.create(n):(r.prototype=n.prototype,new r)}}(),o=this&&this.__awaiter||function(e,t,n,r){return new(n||(n=Promise))(function(o,i){function a(e){try{l(r.next(e))}catch(e){i(e)}}function s(e){try{l(r.throw(e))}catch(e){i(e)}}function l(e){e.done?o(e.value):new n(function(t){t(e.value)}).then(a,s)}l((r=r.apply(e,t||[])).next())})},i=this&&this.__generator||function(e,t){function n(e){return function(t){return r([e,t])}}function r(n){if(o)throw new TypeError("Generator is already executing.");for(;l;)try{if(o=1,i&&(a=2&n[0]?i.return:n[0]?i.throw||((a=i.return)&&a.call(i),0):i.next)&&!(a=a.call(i,n[1])).done)return a;switch(i=0,a&&(n=[2&n[0],a.value]),n[0]){case 0:case 1:a=n;break;case 4:return l.label++,{value:n[1],done:!1};case 5:l.label++,i=n[1],n=[0];continue;case 7:n=l.ops.pop(),l.trys.pop();continue;default:if(a=l.trys,!(a=a.length>0&&a[a.length-1])&&(6===n[0]||2===n[0])){l=0;continue}if(3===n[0]&&(!a||n[1]>a[0]&&n[1]<a[3])){l.label=n[1];break}if(6===n[0]&&l.label<a[1]){l.label=a[1],a=n;break}if(a&&l.label<a[2]){l.label=a[2],l.ops.push(n);break}a[2]&&l.ops.pop(),l.trys.pop();continue}n=t.call(e,l)}catch(e){n=[6,e],i=0}finally{o=a=0}if(5&n[0])throw n[1];return{value:n[0]?n[1]:void 0,done:!0}}var o,i,a,s,l={label:0,sent:function(){if(1&a[0])throw a[1];return a[1]},trys:[],ops:[]};return s={next:n(0),throw:n(1),return:n(2)},"function"==typeof Symbol&&(s[Symbol.iterator]=function(){return this}),s};Object.defineProperty(t,"__esModule",{value:!0});var a=n(0);n(3);var s=function(e){function t(t,n){var r=e.call(this,t)||this;return r.view=document.createElement("wbm-legal-information-wago-licenses"),r.licenseLoader=n,r}return r(t,e),t.prototype.load=function(){return o(this,void 0,void 0,function(){var e,t,n;return i(this,function(r){switch(r.label){case 0:this.view.innerHTML="",e=document.createElement("p"),e.classList.add("license-page-text"),this.view.appendChild(e),r.label=1;case 1:return r.trys.push([1,3,,4]),t=e,[4,this.licenseLoader.getWagoSoftwareLicenseAgreement()];case 2:return t.textContent=r.sent(),[3,4];case 3:return n=r.sent(),this.base.modalPresenter.showErrorDialog(this.base,{title:this.base.localization.localized({key:"error-while-loading-wago-license-modal-title",fallback:"Error"}),message:this.base.localization.localized({key:"error-while-loading-wago-license-modal-message",fallback:"Failed to load WAGO license text resource."}),detailMessage:n.message}),[3,4];case 4:return[2]}})})},t}(a.ViewController);t.WAGOLicenses=s},function(e,t,n){"use strict";var r=this&&this.__extends||function(){var e=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var n in t)t.hasOwnProperty(n)&&(e[n]=t[n])};return function(t,n){function r(){this.constructor=t}e(t,n),t.prototype=null===n?Object.create(n):(r.prototype=n.prototype,new r)}}(),o=this&&this.__awaiter||function(e,t,n,r){return new(n||(n=Promise))(function(o,i){function a(e){try{l(r.next(e))}catch(e){i(e)}}function s(e){try{l(r.throw(e))}catch(e){i(e)}}function l(e){e.done?o(e.value):new n(function(t){t(e.value)}).then(a,s)}l((r=r.apply(e,t||[])).next())})},i=this&&this.__generator||function(e,t){function n(e){return function(t){return r([e,t])}}function r(n){if(o)throw new TypeError("Generator is already executing.");for(;l;)try{if(o=1,i&&(a=2&n[0]?i.return:n[0]?i.throw||((a=i.return)&&a.call(i),0):i.next)&&!(a=a.call(i,n[1])).done)return a;switch(i=0,a&&(n=[2&n[0],a.value]),n[0]){case 0:case 1:a=n;break;case 4:return l.label++,{value:n[1],done:!1};case 5:l.label++,i=n[1],n=[0];continue;case 7:n=l.ops.pop(),l.trys.pop();continue;default:if(a=l.trys,!(a=a.length>0&&a[a.length-1])&&(6===n[0]||2===n[0])){l=0;continue}if(3===n[0]&&(!a||n[1]>a[0]&&n[1]<a[3])){l.label=n[1];break}if(6===n[0]&&l.label<a[1]){l.label=a[1],a=n;break}if(a&&l.label<a[2]){l.label=a[2],l.ops.push(n);break}a[2]&&l.ops.pop(),l.trys.pop();continue}n=t.call(e,l)}catch(e){n=[6,e],i=0}finally{o=a=0}if(5&n[0])throw n[1];return{value:n[0]?n[1]:void 0,done:!0}}var o,i,a,s,l={label:0,sent:function(){if(1&a[0])throw a[1];return a[1]},trys:[],ops:[]};return s={next:n(0),throw:n(1),return:n(2)},"function"==typeof Symbol&&(s[Symbol.iterator]=function(){return this}),s};Object.defineProperty(t,"__esModule",{value:!0});var a=n(0),s=function(e){function t(t){var n=e.call(this,t)||this;return n.didLoad=!1,n.view=document.createElement("wbm-legal-information-wbm-licenses"),n}return r(t,e),t.prototype.load=function(){return o(this,void 0,void 0,function(){var e,t,n,r,o,a,s,l,c,u=this;return i(this,function(i){switch(i.label){case 0:if(this.didLoad)return[3,9];this.didLoad=!0,e=this.view.querySelector("div")||document.createElement("div"),e.classList.add("license-page-text"),t=["LICENSES"].concat(this.base.plugin.getLoaded().map(function(e){return u.base.plugin.getResourceUrl(e.name)+"/LICENSES"})),n="",r=0,o=t,i.label=1;case 1:if(!(r<o.length))return[3,8];a=o[r],i.label=2;case 2:return i.trys.push([2,6,,7]),[4,fetch(a)];case 3:return s=i.sent(),s.ok?(l=n,[4,s.text()]):[3,5];case 4:n=l+i.sent(),i.label=5;case 5:return[3,7];case 6:return c=i.sent(),[3,7];case 7:return r++,[3,1];case 8:e.textContent=n,this.view.appendChild(e),i.label=9;case 9:return[2]}})})},t}(a.ViewController);t.WBMLicenses=s},function(e,t,n){"use strict";var r=this&&this.__awaiter||function(e,t,n,r){return new(n||(n=Promise))(function(o,i){function a(e){try{l(r.next(e))}catch(e){i(e)}}function s(e){try{l(r.throw(e))}catch(e){i(e)}}function l(e){e.done?o(e.value):new n(function(t){t(e.value)}).then(a,s)}l((r=r.apply(e,t||[])).next())})},o=this&&this.__generator||function(e,t){function n(e){return function(t){return r([e,t])}}function r(n){if(o)throw new TypeError("Generator is already executing.");for(;l;)try{if(o=1,i&&(a=2&n[0]?i.return:n[0]?i.throw||((a=i.return)&&a.call(i),0):i.next)&&!(a=a.call(i,n[1])).done)return a;switch(i=0,a&&(n=[2&n[0],a.value]),n[0]){case 0:case 1:a=n;break;case 4:return l.label++,{value:n[1],done:!1};case 5:l.label++,i=n[1],n=[0];continue;case 7:n=l.ops.pop(),l.trys.pop();continue;default:if(a=l.trys,!(a=a.length>0&&a[a.length-1])&&(6===n[0]||2===n[0])){l=0;continue}if(3===n[0]&&(!a||n[1]>a[0]&&n[1]<a[3])){l.label=n[1];break}if(6===n[0]&&l.label<a[1]){l.label=a[1],a=n;break}if(a&&l.label<a[2]){l.label=a[2],l.ops.push(n);break}a[2]&&l.ops.pop(),l.trys.pop();continue}n=t.call(e,l)}catch(e){n=[6,e],i=0}finally{o=a=0}if(5&n[0])throw n[1];return{value:n[0]?n[1]:void 0,done:!0}}var o,i,a,s,l={label:0,sent:function(){if(1&a[0])throw a[1];return a[1]},trys:[],ops:[]};return s={next:n(0),throw:n(1),return:n(2)},"function"==typeof Symbol&&(s[Symbol.iterator]=function(){return this}),s};Object.defineProperty(t,"__esModule",{value:!0});var i=function(){function e(e){this.phpResourceUrl=e}return e.prototype.loadData=function(){return r(this,void 0,void 0,function(){return o(this,function(e){return this.loadingData?[2,this.loadingData]:(this.loadingData=fetch(this.phpResourceUrl,{method:"POST"}).then(function(e){return e.json()}),[2,this.loadingData])})})},e.prototype.loadOSSPackageLicense=function(e){return r(this,void 0,void 0,function(){var t,n;return o(this,function(r){switch(r.label){case 0:return[4,fetch(this.phpResourceUrl,{method:"POST",body:JSON.stringify({package:e})})];case 1:return t=r.sent(),[4,t.json()];case 2:return n=r.sent(),[2,n.license]}})})},e.prototype.getWagoSoftwareLicenseAgreement=function(){return r(this,void 0,void 0,function(){var e;return o(this,function(t){switch(t.label){case 0:return this.data?[3,2]:(e=this,[4,this.loadData()]);case 1:e.data=t.sent(),t.label=2;case 2:return[2,this.data.wagoSoftwareLicenseAgreement]}})})},e.prototype.getOSSDisclaimer=function(){return r(this,void 0,void 0,function(){var e;return o(this,function(t){switch(t.label){case 0:return this.data?[3,2]:(e=this,[4,this.loadData()]);case 1:e.data=t.sent(),t.label=2;case 2:return[2,this.data.ossDisclaimer]}})})},e.prototype.getOSSPackageList=function(){return r(this,void 0,void 0,function(){var e;return o(this,function(t){switch(t.label){case 0:return this.data?[3,2]:(e=this,[4,this.loadData()]);case 1:e.data=t.sent(),t.label=2;case 2:return[2,this.data.ossPackages.map(function(e){return{id:e.id,name:e.name,version:e.version}})]}})})},e.prototype.getOSSPackageLicense=function(e){return r(this,void 0,void 0,function(){var t,n,r;return o(this,function(o){switch(o.label){case 0:return this.data?[3,2]:(t=this,[4,this.loadData()]);case 1:t.data=o.sent(),o.label=2;case 2:return(n=this.data.ossPackages.filter(function(t){return t.id===e})[0])?n.license?[3,4]:(r=n,[4,this.loadOSSPackageLicense(e)]):[3,5];case 3:r.license=o.sent(),o.label=4;case 4:return[2,n.license];case 5:throw new Error("unknown package")}})})},e}();t.LicenseLoader=i},function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),function(e){e.admin="admin",e.user="user",e.guest="guest"}(t.UserRoles||(t.UserRoles={}))}])});
//# sourceMappingURL=legal-information.js.map